package org.fuseri.modulelanguageschool.course;

import jakarta.persistence.*;
import lombok.*;
import org.fuseri.modulelanguageschool.common.DomainObject;
import org.fuseri.modulelanguageschool.user.User;

import java.util.List;

@Getter
@Setter
@Entity
@Table(name = "course")
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class Course extends DomainObject {

    private String name;
    private Integer capacity;

    @Enumerated(EnumType.STRING)
    private Language language;

    @Enumerated(EnumType.STRING)
    private ProficiencyLevel proficiency;

    @ManyToMany
    private List<User> students;

    public void enrolStudent(User student) {
        students.add(student);
    }

    public void expelStudent(User student) {
        students.remove(student);
    }
}
